<?xml version="1.0" encoding="UTF-8"?>
<!--
Document : XMLDocumentoReq1.xsl
Created on : 19 de diciembre de 2011, 11:13
Author : manueldelavilla
Description:
Purpose of transformation follows.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:output method="html"/>
<!-- TODO customize transformation rules
syntax recommendation http://www.w3.org/TR/xslt
-->

    <xsl:template match="/">
        <xsl:for-each select="//DocumentoR">
            <font size="1000"><center><xsl:value-of select = "nombre"/></center></font>
            <font size="40"><center><br/><xsl:value-of select = "creado"/></center></font>
            <font size="40"><center><br/><xsl:value-of select = "fecha"/></center></font>
            <font size="40"><center><br/><xsl:value-of select = "preparado"/></center></font><br/>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- CASO DE USO -->
        <xsl:for-each select="//CasodeUso">
            <b><font size="26">Caso de Uso</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Identificación</b>
                    </td>
                    <td>
                        <b>
                            <xsl:value-of select = "identificacion"/>
                        </b>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Nombre</b>
                    </td>
                    <td>
                        <b>
                            <xsl:value-of select = "nombre"/>
                        </b>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Unidad de frecuencia</b>
                    </td>
                    <td>
                        <xsl:value-of select = "unidadFrecuencia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Frecuencia</b>
                    </td>
                    <td>
                        <xsl:value-of select = "frecuencia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Evento de activación</b>
                    </td>
                    <td>
                        <xsl:value-of select = "eventoActivacion"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Precondición</b>
                    </td>
                    <td>
                        <xsl:value-of select = "precondicion"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Postcondición</b>
                    </td>
                    <td>
                        <xsl:value-of select = "postcondicion"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Importacia</b>
                    </td>
                    <td>
                        <xsl:value-of select = "importancia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Urgencia</b>
                    </td>
                    <td>
                        <xsl:value-of select = "urgencia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Estabilidad</b>
                    </td>
                    <td>
                        <xsl:value-of select = "estabilidad"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Estado de desarrollo</b>
                    </td>
                    <td>
                        <xsl:value-of select = "estadodeDesarrollo"/>
                    </td>
                </tr>
            <!-- PASO CASO DE USO -->
                <tr>
                    <td>
                        <b>Pasos</b>
                    </td>
                    <td>
                        <xsl:for-each select="./PasoCU">
                            <xsl:value-of select="identP"/>.
                            <xsl:value-of select = "accionP"/>
                            <br/>
                        </xsl:for-each>
                    </td>
                </tr>
            <!-- EXCEPCION PASO CASO DE USO -->
                <tr>
                    <td>
                        <b>Excepciones</b>
                    </td>
                    <td>
                        <xsl:for-each select="//ExcepcionCU">
                            <xsl:value-of select="identE"/>.
                            <xsl:value-of select = "accionE"/>
                            <br/>
                        </xsl:for-each>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- SECCION -->
        <xsl:for-each select="//Seccion">
            <b><font size="26">Sección/Apéndice</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Identificacion</b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Seccion normal</b>
                    </td>
                    <td>
                        <xsl:value-of select="seccionNormal"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Seccion apendice</b>
                    </td>
                    <td>
                        <xsl:value-of select="seccionApendice"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Orden</b>
                    </td>
                    <td>
                        <xsl:value-of select="orden"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Comentarios</b>
                    </td>
                    <td>
                        <xsl:value-of select="comentarios"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- PARRAFO -->
        <xsl:for-each select="//Parrafo">
            <b><font size="26">Párrafo/Glosario</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Identificador</b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Texto</b>
                    </td>
                    <td>
                        <xsl:value-of select="texto"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Tipo de Párrafo</b>
                    </td>
                    <td>
                        <xsl:value-of select="tipoparrafo"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Comentarios</b>
                    </td>
                    <td>
                        <xsl:value-of select="comentarios"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- FICHERO GRAFICO -->
        <xsl:for-each select="//FicheroGrafico">
            <b><font size="26">Fichero Gráfico</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Identificador</b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Fichero</b>
                    </td>
                    <td>
                        <xsl:value-of select="fich"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Comentarios</b>
                    </td>

                    <td>
                        <xsl:value-of select="comentarios"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- ORGANIZACION -->
        <xsl:for-each select="//Organizacion">
            <b><font size="26">Organización</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Identificacion</b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Dirección</b>
                    </td>
                    <td>
                        <xsl:value-of select="direccion"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Teléfono</b>
                    </td>
                    <td>
                        <xsl:value-of select="tlfn"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Fax</b>
                    </td>
                    <td>
                        <xsl:value-of select="fax"/>
                    </td>
                </tr>
                <tr>
                    <td >
                        <b>Participantes</b>
                    </td>
                    <td>
                        <xsl:for-each select=".//PartiO">
                            <xsl:value-of select="identP"/>. <xsl:value-of select="nombreP"/><br/>
                        </xsl:for-each>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Comentario</b>
                    </td>
                    <td>
                        <xsl:value-of select="comentario"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- PARTICIPANTE -->
        <xsl:for-each select="//Participante">
            <b><font size="26">Participante</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Identificacion</b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Rol</b>
                    </td>
                    <td>
                        <xsl:value-of select="rol"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Organizacion</b>
                    </td>
                    <td>
                        <xsl:value-of select="organizacion"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>EsCliente</b>
                    </td>
                    <td>
                        <xsl:value-of select="esCliente"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>EsDesarrollador</b>
                    </td>
                    <td>
                        <xsl:value-of select="esDesarrollador"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>EsUsuario</b>
                    </td>
                    <td>
                        <xsl:value-of select="esUsuario"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- REUNION -->
        <xsl:for-each select="//Reunion">
            <b><font size="26">Reunión</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Identificación</b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Lugar</b>
                    </td>
                    <td>
                        <xsl:value-of select="LUGAR"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Fecha</b>
                    </td>
                    <td>
                        <xsl:value-of select="fecha"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Asitentes</b>
                    </td>
                    <td>
                        <xsl:value-of select="asistentes"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Resultados</b>
                    </td>
                    <td>
                        <xsl:value-of select="resultados"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- REQUISITO DE RESTRICCION -->
        <xsl:for-each select="//RequisitoRestriccion">
            <b><font size="26">Requisito de Restricción</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Identificación</b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Descripción</b>
                    </td>
                    <td>
                        <xsl:value-of select="descripcion"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Importancia</b>
                    </td>
                    <td>
                        <xsl:value-of select="importancia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Urgencia</b>
                    </td>
                    <td>
                        <xsl:value-of select="urgencia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Estado de desarrollo</b>
                    </td>
                    <td>
                        <xsl:value-of select="estado"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Estabilidad</b>
                    </td>
                    <td>
                        <xsl:value-of select="estabilidad"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- REQUISITO DE INFORMACION -->
        <xsl:for-each select="//RequisitoInformacion">
            <b><font size="26">Requisito de Información</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Identificación</b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="Nombre"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Concepto</b>
                    </td>
                    <td>
                        <xsl:value-of select="concepto"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Valor Max.</b>
                    </td>
                    <td>
                        <xsl:value-of select="valorMax"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Unidad tiempo Max.</b>
                    </td>
                    <td>
                        <xsl:value-of select="unidadTMax"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Valor medio</b>
                    </td>
                    <td>
                        <xsl:value-of select="valorMed"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Unidad de tiempo Medio</b>
                    </td>
                    <td>
                        <xsl:value-of select="unidadTMe"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Número Max.</b>
                    </td>
                    <td>
                        <xsl:value-of select="numeroMax"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Número Medio</b>
                    </td>
                    <td>
                        <xsl:value-of select="numeroMed"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Importancia</b>
                    </td>
                    <td>
                        <xsl:value-of select="importancia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Urgencia</b>
                    </td>
                    <td>
                        <xsl:value-of select="urgencia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Estado de desarrollo</b>
                    </td>
                    <td>
                        <xsl:value-of select="estado"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Estabilidad</b>
                    </td>
                    <td>
                        <xsl:value-of select="estabilidad"/>
                    </td>
                </tr>
            <!-- DATO ESPECIFICO -->
                <tr>
                    <td>
                        <b>Descripción Dato Especifico</b>
                    </td>
                    <td>
                        <xsl:for-each select=".//DatoEsp">
                            <xsl:value-of select="ident"/>. <xsl:value-of select="descripcion"/><br/>
                        </xsl:for-each>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- REQUISITO FUNCIONAL -->
        <xsl:for-each select="//RequisitoFuncional">
            <b><font size="26">Requisito funcional</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Identificación</b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Descripción</b>
                    </td>
                    <td>
                        <xsl:value-of select="descripcion"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Importancia</b>
                    </td>
                    <td>
                        <xsl:value-of select="importancia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Urgencia</b>
                    </td>
                    <td>
                        <xsl:value-of select="urgencia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Estado de desarrollo</b>
                    </td>
                    <td>
                        <xsl:value-of select="estado"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Estabilidad</b>
                    </td>
                    <td>
                        <xsl:value-of select="estabilidad"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- REQUISITO NO FUNCIONAL -->
        <xsl:for-each select="//RequisitoNoFuncional">
            <b><font size="26">Requisito no funcional</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Identificación</b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Descripción</b>
                    </td>
                    <td>
                        <xsl:value-of select="descripcion"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Importancia</b>
                    </td>
                    <td>
                        <xsl:value-of select="importancia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Urgencia</b>
                    </td>
                    <td>
                        <xsl:value-of select="urgencia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Estado de desarrollo</b>
                    </td>
                    <td>
                        <xsl:value-of select="estado"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Estabilidad</b>
                    </td>
                    <td>
                        <xsl:value-of select="estabilidad"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- ACTOR -->
        <xsl:for-each select="//Actor">
            <b><font size="26">Actor</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Identificación</b>
                    </td>
                    <td>
                        <xsl:value-of select="identificacion"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>

                </tr>
                <tr>
                    <td>
                        <b>Descripcion</b>
                    </td>
                    <td>
                        <xsl:value-of select="descripcion"/>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- OBJETIVO -->
        <xsl:for-each select="//Objetivo">
            <b><font size="26">Objetivo</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Identificación</b>
                    </td>
                    <td>
                        <xsl:value-of select="ident"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Descripcion</b>
                    </td>
                    <td>
                        <xsl:value-of select="descripcion"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Importancia</b>
                    </td>
                    <td>
                        <xsl:value-of select="importancia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Urgencia</b>
                    </td>
                    <td>
                        <xsl:value-of select="urgencia"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Estado</b>
                    </td>
                    <td>
                        <xsl:value-of select="estado"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Estabilidad</b>
                    </td>
                    <td>
                        <xsl:value-of select="estabilidad"/>
                    </td>
                </tr>
            <!-- SUBOBJETIVO -->
                <tr>
                    <td>
                        <b>Subobjetivos</b>
                    </td>
                    <td>
                        <xsl:for-each select=".//Subobjetivo">
                            <xsl:value-of select="identSO"/>. <xsl:value-of select = "descripcionSO"/>
                            <br/>
                        </xsl:for-each>
                    </td>
                </tr>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
<!-- MATRIZ DE RASTREABILIDAD -->
        <xsl:for-each select="//MatrizRastreabilidad">
            <b><font size="26">Matriz de Rastreabilidad</font></b><br/>
            <table border="1" width="80%" align="Center">
                <tr>
                    <td width="20%">
                        <b>Nombre</b>
                    </td>
                    <td>
                        <xsl:value-of select="nombre"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <b>Comentarios</b>
                    </td>
                    <td>
                        <xsl:value-of select="comentarios"/>
                    </td>
                </tr>
            </table>
            <table border="1" align="Center">
                <tr>
                    <th>
                        <xsl:value-of select="ident"/>
                    </th>
                    <xsl:for-each select="//mColumna">
                        <th>
                            <xsl:value-of select="cm"/>
                            <br/>
                        </th>
                    </xsl:for-each>
                </tr>
                <xsl:for-each select="//mFila">
                    <tr>
                        <th>
                        <xsl:value-of select="fm"/>
                        </th>
                        <xsl:for-each select="./aux">
                            <td>
                                <xsl:if test="./traza = 'tr2'">*</xsl:if>
                                <xsl:if test="./traza = 'tr1'">-</xsl:if>
                            </td>
                        </xsl:for-each>
                    </tr>
                </xsl:for-each>
            </table>
            <HR WIDTH="100%" SIZE="2" ALIGN="Center"></HR>
        </xsl:for-each>
    </xsl:template>
</xsl:stylesheet>