/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package imagenes;

import java.awt.Component;
import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

/**
 * Clase RenederArbol, esta clase es la que inseta los iconos en el JTree
 */
public class RendererArbol extends DefaultTreeCellRenderer{
    /**
     * Icono actor
     */
    ImageIcon actor;
    /**
     * Icono caso de uso
     */
    ImageIcon casouso;
    /**
     * Icono dato especifico
     */
    ImageIcon datoEsp;
    /**
     * Icono documento de requerimiento
     */
    ImageIcon docum;
    /**
     * Icono elemento
     */
    ImageIcon parrafo;
    /**
     * Icono excepción
     */
    ImageIcon excepcion;
    /**
     * Icono requisito funcional
     */
    ImageIcon funcional;
    /**
     * Icono requisito información
     */
    ImageIcon informacion;
    /**
     * Icono requisito no funcional
     */
    ImageIcon nofuncional;
    /**
     * Icono objetivo
     */
    ImageIcon objetivo;
    /**
     * Icono participante
     */
    ImageIcon participante;
    /**
     * Icono paso
     */
    ImageIcon paso;
    /**
     * Icono requisito restricción
     */
    ImageIcon restriccion;
    /**
     * Icono reunión
     */
    ImageIcon reunion;
    /**
     * Icono subobjetivo
     */
    ImageIcon subobjetivo;
    /**
     * Icono matriz de ratreabilidad
     */
    ImageIcon matriz;
    /**
     * Icono fichero gráfico
     */
    ImageIcon fichero;
    /**
     * Icono seccion
     */
    ImageIcon seccion;
    /**
     * Icono organización
     */
    ImageIcon organizacion;

    /**
     * Constructor de RenderArbol coloca las imagenes por defecto en las variables correspondientes.
     */
    public RendererArbol() {
        actor = new ImageIcon("src/imagenes/actor.jpg");
        casouso = new ImageIcon("src/imagenes/casouso.jpg");
        datoEsp = new ImageIcon("src/imagenes/datoEspecifico.jpg");
        docum = new ImageIcon("src/imagenes/documento.jpg");
        parrafo = new ImageIcon("src/imagenes/parrafo.jpg");
        excepcion = new ImageIcon("src/imagenes/excepcion.jpg");
        funcional = new ImageIcon("src/imagenes/funcional.jpg");
        informacion = new ImageIcon("src/imagenes/informacion.jpg");
        nofuncional = new ImageIcon("src/imagenes/nofuncional.jpg");
        objetivo = new ImageIcon("src/imagenes/objetivo.jpg");
        participante = new ImageIcon("src/imagenes/participante.jpg");
        paso = new ImageIcon("src/imagenes/paso.jpg");
        restriccion = new ImageIcon("src/imagenes/restriccion.jpg");
        reunion = new ImageIcon("src/imagenes/reunion.jpg");
        subobjetivo = new ImageIcon("src/imagenes/subobjetivo.jpg");
        matriz = new ImageIcon("src/imagenes/matrizRastr.jpg");
        fichero = new ImageIcon("src/imagenes/ficherografico.jpg");
        seccion = new ImageIcon("src/imagenes/seccion.jpg");
        organizacion = new ImageIcon("src/imagenes/organizacion.jpg");
    }

    /**
     * Metodo para comprobar que tipo de nodo es e insertar su icono
     * @param tree le pasamos el JTree a modificar
     * @param value
     * @param selected
     * @param expanded
     * @param leaf
     * @param row
     * @param hasFocus
     * @return JTree modificado
     */
    @Override
    public Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) {
        super.getTreeCellRendererComponent(tree, value, selected, expanded, leaf, row, hasFocus);
        DefaultMutableTreeNode nodo = (DefaultMutableTreeNode) value;

        if (nodo.toString().contains("ACT")) {
            setIcon(actor);
        }
        if (nodo.toString().contains("CU")) {
            setIcon(casouso);
        }
        if (nodo.toString().contains("DAT")) {
            setIcon(datoEsp);
        }
        if (nodo.toString().contains("Documento")) {
            setIcon(docum);
        }
        if (nodo.toString().contains("PARR")) {
            setIcon(parrafo);
        }
        if (nodo.toString().startsWith("EXCU")) {
            setIcon(excepcion);
        }
        if (nodo.toString().contains("RF")) {
            setIcon(funcional);
        }
        if (nodo.toString().contains("RI")) {
            setIcon(informacion);
        }
        if (nodo.toString().contains("RNF")) {
            setIcon(nofuncional);
        }
        if (nodo.toString().contains("OB")) {
            setIcon(objetivo);
        }
        if (nodo.toString().contains("PART")) {
            setIcon(participante);
        }
        if (nodo.toString().startsWith("PCU")) {
            setIcon(paso);
        }
        if (nodo.toString().contains("RRE")) {
            setIcon(restriccion);
        }
        if (nodo.toString().contains("REU")) {
            setIcon(reunion);
        }
        if (nodo.toString().contains("SUBO")) {
            setIcon(subobjetivo);
        }
        if (nodo.toString().contains("MAT")) {
            setIcon(matriz);
        }
        if (nodo.toString().contains("FICH")) {
            setIcon(fichero);
        }
        if (nodo.toString().contains("SECC")) {
            setIcon(seccion);
        }
        if (nodo.toString().contains("ORG")) {
            setIcon(organizacion);
        }

        return this;

    }
}


