package modelo;

import java.io.Serializable;
import java.util.ArrayList; 
import java.util.List;
import java.util.Observable;
import javax.persistence.*;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.19C2A8B9-8EBE-0673-03C0-C90C4B7E5CE6]
// </editor-fold>
/**
 *
 * Clase CasodeUso, identifica <b>un caso de uso.</b>
 */
@Entity
@Table (name="CasodeUso ")
public class CasodeUso extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    @Transient
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    @Column (name="id_n ")
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.01EE0296-44AC-2152-EA43-83694BDC923A]
    // </editor-fold>
    /**
     * Con esta variable identificamos el nombre.
     */
    @Column (name="nameCU ")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.6E983FF8-18C3-4C5F-7CD3-4F8C444DEE8E]
    // </editor-fold>
    /**
     * Con esta variable identificamos si el caso de uso es abstracto.
     */
    @Column (name="isAbstract ")
    private boolean esAbstracto;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.4D9D8FE9-150B-D7AB-BA5D-D5B052B79BF6]
    // </editor-fold>
    /**
     * Con esta variable identificamos el evento de como se activa el caso de uso.
     */
    @Column (name="activationEvent ")
    private String eventoActivacion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.50A81C5C-2468-4D5B-90F8-F62970D63EF1]
    // </editor-fold>
    /**
     * Con esta variable identificamos el entero de la frecuencia del caso de uso.
     */
    @Column (name="frecuency ")
    private int frecuencia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.A5F6DE06-F98D-56B3-F548-3FC202D93D8A]
    // </editor-fold>
    /**
     * Con esta variable identificamos la unidad de la frecuencia del caso de uso
     */
    @Column (name="frecuencyUnit ")
    private String unidadFrecuencia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.9D988DE6-7E69-C26E-6532-B9FC30D9C677]
    // </editor-fold>
    /**
     * Con esta variable identificamos la precondición para el caso de uso.
     */@Column (name="precondition ")
    private String precondicion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.31FDBEF8-E85C-1DB3-E9FC-BEB9C220817E]
    // </editor-fold>
    /**
     * Con esta variable identificamos la postcondición para el caso de uso.
     */
     @Column (name="postcondition ")
    private String postcondicion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.AF676AE3-7D48-8C2A-FFD2-2E5455B97A71]
    // </editor-fold>
    /**
     * Con esta variable identificamos la importancia del caso de uso.
     */
     @Column (name="importance ")
    private String importancia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.99AE1478-E429-2565-EB55-602957C082C1]
    // </editor-fold>
    /**
     * Con esta variable identificamos la urgencia del caso de uso.
     */
     @Column (name="urgency ")
    private String urgencia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.813A6739-072B-CA47-E875-0D33AB415FB4]
    // </editor-fold>
    /**
     * Con esta variable identificamos el estado de desarrollo en el que esta el caso de uso.
     */
     @Column (name="stateDevelopment ")
    private String estadodeDesarrollo;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.22CFA52C-258D-FD88-3173-2BA9CBF6A639]
    // </editor-fold>
    /**
     * Con esta variable identificamos la estabilidad del caso de uso.
     */
     @Column (name="stability ")
    private String estabilidad;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.54819111-C41A-2842-C181-BC7A95F289C1]
    // </editor-fold>
    /**
     * Con esta variable identificamos el array de paso del caso de uso.
     */
    @OneToMany(mappedBy = "mCasodeUso")
    private List<PasoCU> mPasoCU;

    /**
     * Constructor del caso de uso
     */
    public CasodeUso () {
        mPasoCU = new ArrayList<PasoCU>();
    }

    /**
     * Método que permite saber si es abstracto el caso de uso
     * @return si es abstracto o no de un caso de uso.
     */
    public boolean getEsAbstracto () {
        return esAbstracto;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.9FFF124D-2392-D2CB-B263-1517FD4A2521]
    // </editor-fold>
    /**
     * Método que permite insertar si es abstracto o no un caso de uso.
     * @param val si un caso de uso es abstracto o no.
     */
    public void setEsAbstracto (boolean val) {
        this.esAbstracto = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.289E30CB-F75E-625F-FCD5-1A0D092FCCE4]
    // </editor-fold>
    /**
     * Método que permite saber la estabilidad de un caso de uso.
     * @return la estabilidad de un caso de uso
     */
    public String getEstabilidad () {
        return estabilidad;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.8484F10E-9403-E4E4-3D90-250DC58F40F1]
    // </editor-fold>
    /**
     * Método que permite insertar la estabilidad de un caso de uso.
     * @param val la estabilidad en un caso de uso.
     */
    public void setEstabilidad (String val) {
        this.estabilidad = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.41D532F3-13C6-D628-3F31-87B518274405]
    // </editor-fold>
    /**
     * Método que permite saber el estado de desarrollo del caso de uso.
     * @return el estado de desarrollo de un caso de uso
     */
    public String getEstadodeDesarrollo () {
        return estadodeDesarrollo;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.92827533-CD8D-DF5B-6A5A-ED25AF0A5A4B]
    // </editor-fold>
    /**
     * Método que permite insertar un estado de desarrollo en un caso de uso.
     * @param val el estado de desarrollo a insertar en un caso de uso
     */
    public void setEstadodeDesarrollo (String val) {
        this.estadodeDesarrollo = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1681E49F-574A-E7F7-4CAA-95237C7F2818]
    // </editor-fold>
    /**
     * Método que permite saber el evento de activación del caso de uso
     * @return el evento de activación de un caso de uso
     */
    public String getEventoActivacion () {
        return eventoActivacion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.462CB85D-00E1-FD3C-B2CF-611E16BAEF68]
    // </editor-fold>
    /**
     * Método que permite insertar un evento de activacion en un caso de uso
     * @param val el evento de activación a insertar en un caso de uso.
     */
    public void setEventoActivacion (String val) {
        this.eventoActivacion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.58B1F5A1-BA30-F425-FAE2-53EB7B13015A]
    // </editor-fold>
    /**
     * Método que permite saber la frecuencia con que se va a dar un caso de uso
     * @return el entero con la frecuencia de un caso de uso
     */
    public int getFrecuencia () {
        return frecuencia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.C57D533E-6AA4-16CF-5E5E-FE0B74A432BE]
    // </editor-fold>
    /**
     * Método que permite insertar la frecuencia de un caso de uso
     * @param val la frecuencia a insertar en un caso de uso.
     */
    public void setFrecuencia (int val) {
        this.frecuencia = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.A7DFA385-81A3-933F-3C76-7B5AC6DDB0B7]
    // </editor-fold> 
    /**
     * Método que permite saber la importancia en un caso de uso
     * @return la importancia de un caso de uso
     */
    public String getImportancia () {
        return importancia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F78E118F-B368-022B-481B-B42D712460CE]
    // </editor-fold>
    /**
     * Método que permite insertar la importancia en un caso de uso
     * @param val la importancia a insertar en un caso de uso
     */
    public void setImportancia (String val) {
        this.importancia = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.2C38A3C2-B871-7914-3FE0-02B567093F49]
    // </editor-fold>
    /**
     * Método que permite conocer todos los pasos de un caso de uso
     * @return el array con todos los pasos de un caso de uso
     */
    public List<PasoCU> getPasoCU () {
        return (List<PasoCU>) mPasoCU;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.3B83B548-FAE3-4183-377F-B9E4B0DD1E4F]
    // </editor-fold>
    /**
     * Método que permite insertar pasos en un caso de uso
     * @param val el paso a insertar en un caso de uso
     */
    public void setPasoCU (List<PasoCU> val) {
        this.mPasoCU = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.B149A00A-CB78-8330-2387-CDD5EE2D289C]
    // </editor-fold>
    /**
     * Método que permite saber el nombre de un caso de uso
     * @return el nombre de un caso de uso
     */
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7CD3AE27-5A6E-5F79-A61B-C93AD26D215A]
    // </editor-fold>
    /**
     * Método que permite insertar el nombre un caso de uso
     * @param val el nombre a insertar en el caso de uso
     */
    public void setNombre (String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.050EFF91-E1C2-8D07-4F77-74DC394814AD]
    // </editor-fold>
    /**
     * Método que permite saber la postcondición de un caso de uso
     * @return la postcondición de un caso de uso
     */
    public String getPostcondicion () {
        return postcondicion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.103C0B58-D33B-CBD5-CC6E-5650A40CCF09]
    // </editor-fold>
    /**
     * Método que permite insertar la postcondición de un caso de uso
     * @param val la postcondición de un caso de uso
     */
    public void setPostcondicion (String val) {
        this.postcondicion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.FF678302-5DD9-C3A8-3B22-6ED408DC744E]
    // </editor-fold>
    /**
     * Método que permite saber la precondición de un caso de uso
     * @return la precondición de un caso de uso
     */
    public String getPrecondicion () {
        return precondicion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7FEEC2CE-9C53-7915-2E79-4C15D7DF3E4A]
    // </editor-fold>
    /**
     * Método que permite insertar la precondición de un caso de uso
     * @param val la precondición de un caso de uso
     */
    public void setPrecondicion (String val) {
        this.precondicion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.FD6EE2E9-715A-7EB2-BCC0-287A0C9DA6A6]
    // </editor-fold>
    /**
     * Método que permite saber la unidad de frecuencia de un caso de uso
     * @return la unidad de frecuencia de un caso de uso
     */
    public String getUnidadFrecuencia () {
        return unidadFrecuencia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.4544898F-CD46-5497-6897-03140B174F9F]
    // </editor-fold>
    /**
     * Método que permite insertar la unidad de frecuencia de un caso de uso
     * @param val la unidad de frecuencia de un caso de uso
     */
    public void setUnidadFrecuencia (String val) {
        this.unidadFrecuencia = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.A216D280-E5FE-88D2-DC11-A94342219188]
    // </editor-fold>
    /**
     * Método que permite saber la urgencia de un caso de uso
     * @return la urgencia de un caso de uso
     */
    public String getUrgencia () {
        return urgencia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.AC8675F0-E077-D930-FD91-9617E3CE4161]
    // </editor-fold>
    /**
     * Método que permite insertar la urgencia de un caso de uso
     * @param val la urgencia de un caso de uso
     */
    public void setUrgencia (String val) {
        this.urgencia = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.35434101-F3FB-D247-B326-63D6BF7E31A0]
    // </editor-fold>
    /**
     * Método que permite insertar un nuevo paso a un caso de uso
     * @param Id es el número que se le pasa para el identificador
     * @param esCondicional si es condicional o no el paso
     * @param condicion la condición del paso
     * @param AccionSistema si es o no acción del sistema
     * @param AccionActor si es o no acción del actor
     * @param InclusionExtension si es o no inclusión/extensión
     * @param Actor el actor que requiere este paso
     * @param IE el tipo de inclusión/ extensión
     * @param Accion descripción de la acción
     * @param valor el valor del rendimiento del paso
     * @param unidad en que es medido el valor
     * @param comentario general de lo que se realiza en el paso
     * @return el paso con todas las variables que se le han pasado como parametro insertadas.
     */
    public PasoCU nuevoPaso (int Id, String IdentC, boolean esCondicional, String condicion, boolean AccionSistema, boolean AccionActor, boolean InclusionExtension, String Actor, String IE, String Accion, int valor, String unidad, String comentario) {
        //// Creo la instancia
        PasoCU auxPCU=new PasoCU();
        //// Asigno los valores a los atributos
        auxPCU.setId("PCU");
        auxPCU.setId_n(Id);
        auxPCU.setIdent(auxPCU.getId()+String.valueOf(Id)+". "+IdentC);
        auxPCU.setCondicion(condicion);
        auxPCU.setEsCondicional(esCondicional);
        auxPCU.setAccionSistema(AccionSistema);
        auxPCU.setAccionActor(AccionActor);
        auxPCU.setInclusionExtension(InclusionExtension);
        auxPCU.setActor(Actor);
        auxPCU.setIE(IE);
        auxPCU.setAccion(Accion);
        auxPCU.setUnidad(unidad);
        auxPCU.setValor(valor);
        auxPCU.setComentarios(comentario);
                //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getPasoCU().add(auxPCU);
        persist(auxPCU);
        return auxPCU;
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final CasodeUso other = (CasodeUso) obj;
        if ((this.ident == null) ? (other.ident != null) : !this.ident.equals(other.ident)) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 83 * hash + (this.ident != null ? this.ident.hashCode() : 0);
        return hash;
    }

    @Override
    public String toString() {
        return super.toString();
    }

    public static List getData (String opt) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        return emf.createEntityManager().createQuery("SELECT p FROM CasodeUso p").getResultList();
    }

    public void eliminarBD (CasodeUso p){
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            for (int i =0; i<p.getPasoCU().size(); i++){
                p.eliminarPEBD(p.getPasoCU().get(i), p.getIdent());
            }
            Query q = em.createQuery("SELECT p FROM CasodeUso p WHERE p.ident = '" + p.getIdent() + "'");
            CasodeUso cu = (CasodeUso) q.getSingleResult();
            em.remove(cu);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    public void actualizarBD (CasodeUso p){
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            CasodeUso cu = em.find(CasodeUso.class, p.getIdent());
            cu.setNombre(p.getNombre());
            cu.setEsAbstracto(p.getEsAbstracto());
            cu.setEventoActivacion(p.getEventoActivacion());
            cu.setFrecuencia(p.getFrecuencia());
            cu.setUnidadFrecuencia(p.getUnidadFrecuencia());
            cu.setPrecondicion(p.getPrecondicion());
            cu.setPostcondicion(p.getPostcondicion());
            cu.setImportancia(p.getImportancia());
            cu.setUrgencia(p.getUrgencia());
            cu.setEstadodeDesarrollo(p.getEstadodeDesarrollo());
            cu.setEstabilidad(p.getEstabilidad());
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    public void eliminarPEBD (PasoCU p, String ident){
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            Query q = em.createQuery("SELECT p FROM PasoCU p WHERE p.mCasodeUso.ident = '" + ident + "'");
            List<PasoCU> ps = (List<PasoCU>) q.getResultList();
            if (ps.size() > 0) {
                for (int i = 0; i < ps.size(); i++) {
                    ps.get(i).eliminarPBD(ps.get(i), ident);
                }
            }
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param el identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

     /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param el entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param la cadena id a insertar
     */
    public void setId(String id) {
        this.id = id;
    }

}

