package modelo;

import java.io.Serializable;
import java.util.Observable;
import javax.persistence.*;


// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.A49C127A-EAF7-DA92-19E6-5F4AE15E6EBA]
// </editor-fold>
/**
 * Clase DatoEspecifico, identifica un dato que se encuentre dentro de un <b>requisito de información</b>.
 */
@Entity
@Table (name="Dato especifico")
public class DatoEspecifico extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.27822AA5-42C4-9BB5-263A-BC7A2383F4CC]
    // </editor-fold>
    /**
     * Con esta variable identificamos la descripción del dato
     */
    @Column (name="description")
    private String descripcion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.216A728E-DEC1-A87B-72A7-9B69B952E2EE]
    // </editor-fold>
    /**
     * Constructor de la clase dato especifico
     */
    public DatoEspecifico () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.A64E517D-BD39-F4B8-01F8-ECE57A89FEE6]
    // </editor-fold>
    /**
     * Metodo que permite devolver la descripcion
     * @return la descripcion
     */
    public String getDescripcion () {
        return descripcion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D8B5F3CA-C32B-897A-55C0-0B894503C1B3]
    // </editor-fold>
    /**
     * Metodo que permite insertar la descripcion
     * @param val es la descripcion a insertar
     */
    public void setDescripcion (String val) {
        this.descripcion = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param la cadena id a insertar
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param el entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param el identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

}

