package modelo;

import java.io.Serializable;
import java.util.Observable;
import javax.persistence.*;


// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.CFB838EE-95B7-9942-A4A1-6813F604E3CD]
// </editor-fold> 
/**
 *
 * Clase MatrizRastreabilidad, identifica a una <b>matriz</b>.
 */
@Entity
@Table(name="Matrix")
public class MatrizRastreabilidad extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.CD8CC9E4-D346-C2C5-4BF4-AE8AF0A5B00F]
    // </editor-fold> 
    /**
     *Variable que guarda el nombre
     */
    @Column(name="name Matrix")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F4E3761A-B58D-F40E-EDC1-EB505D375688]
    // </editor-fold>

    /**
     * Array de la fila
     */
    @OneToMany
    private String fila;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.45F16911-6814-1A1B-B9AF-AB013991AC1B]
    // </editor-fold> 

    /**
     * Array de las columnas
     */
    @OneToMany
    private String columna;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.0847D976-AB74-D396-E398-93A204B939AE]
    // </editor-fold> 
    /**
     * Variable donde guarda el comentario
     */
    @Column(name="comment")
    private String comentarios;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.B4E9EF27-5079-D4F7-803E-B42C700748C7]
    // </editor-fold> 
    /**
     * Constructor de la MatrizRastreabilidad
     */
    public MatrizRastreabilidad () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1F75ED5A-0600-6D7C-69F4-A88FD958C9E7]
    // </editor-fold> 
    /**
     * Metodo que devuelve el comentario
     * @return comentarios
     */
    public String getComentarios () {
        return comentarios;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.EE7F5E7C-1B43-AB3E-31B6-487A878C686C]
    // </editor-fold> 
    /**
     * Metodo que añade un comentario
     * @param val 
     */
    public void setComentarios (String val) {
        this.comentarios = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.BE8A7775-4333-783E-1444-38E73670785E]
    // </editor-fold> 
    /**
     * Metodo que devuelve el nombre de la matriz
     * @return nombre
     */
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D6548A60-1608-79F1-BA1B-580771BD93D5]
    // </editor-fold> 
    /**
     * Metodo que añade el nombre de la matriz
     * @param val 
     */
    public void setNombre (String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * @return the fila
     */
    public String getFila() {
        return fila;
    }

    /**
     * @param fila the fila to set
     */
    public void setFila(String fila) {
        this.fila = fila;
    }

    /**
     * @return the columna
     */
    public String getColumna() {
        return columna;
    }

    /**
     * @param columna the columna to set
     */
    public void setColumna(String columna) {
        this.columna = columna;
    }

    /**
     * Metodo que devuelve el Id
     * @return the id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que añade el Id
     * @param id the id to set
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve el Id_n
     * @return the id_n
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que añade el Id_n
     * @param id_n the id_n to set
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el Ident
     * @return the ident
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que añade el Ident
     * @param ident the ident to set
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }
}

