package modelo;

import java.io.Serializable;
import java.util.ArrayList; 
import java.util.List;
import java.util.Observable;
import javax.persistence.*;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.945E4F48-725A-2C17-FAD4-28871E439FA4]
// </editor-fold>
/**
 *
 * Clase PasoCu, identifica a un <b>paso de un caso de uso</b>.
 */
@Entity
@Table (name="PasoCU ")
public class PasoCU extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    @Transient
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    @Column (name="id_n ")
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id 
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.DF0A07DA-19CF-AB5F-66C3-7DE15E57CE31]
    // </editor-fold>
    /**
     * Con esta variable guardamos la condicion
     */
    @Column (name="conditionPCU ")
    private String condicion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.39075D4C-4598-FC3D-D6DD-D3BE8376266F]
    // </editor-fold>
    /**
     * Con esta variable guardamos si es condicion 
     */
    @Column (name="isConditional ")
    private boolean esCondicional;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.9FA39843-548E-DA30-2A8E-02BFA904C233]
    // </editor-fold>
    /**
     * Con esta variable guardamos el valor
     */
    @Column (name="value ")
    private int valor;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.64C79C98-0C17-3AB4-38DC-D18A4C47421E]
    // </editor-fold>
    /**
     * Con esta variable guardamos la unidad
     */
    @Column (name="unit ")
    private String unidad;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.49F77ACA-66D3-9249-0F4C-1D6C4F5822BE]
    // </editor-fold> 
    /**
     * Con esta variable guardamos el comentario
     */
    @Column (name="comment ")
    private String comentarios;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.373E6E14-7039-D5D8-2B94-7043EEDF3857]
    // </editor-fold>
    /**
     * Con esta variable guardamos la accion
     */
    @Column (name="action ")
    private String Accion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.A9B81D7D-0DCE-1FA6-671B-ABBC100C6DC0]
    // </editor-fold>
    /**
     * Con esta variable guardamos si es una accion del sistema
     */
    @Column (name="isActionSistem ")
    private boolean AccionSistema;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.4C37781E-22FA-185B-DF9E-CFBF092E17DF]
    // </editor-fold>
    /**
     * Con esta variable guardamos si es una accion del actor
     */
    @Column (name="isActionActor ")
    private boolean AccionActor;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.54706D95-97CB-E57D-AFE0-84E9A599088C]
    // </editor-fold>
    /**
     * Con esta variable guardamos si es una inlusion/exclusiom
     */
    @Column (name="isActionIE")
    private boolean InclusionExtension;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.096102EC-F651-6DD3-355E-ADF38BB6DA46]
    // </editor-fold>
    /**
     * Con esta variable guardamos el actor
     */
    @Column (name="actionActor ")
    private String Actor;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.BD345560-5FA0-D7CD-2FDA-AD70425B8705]
    // </editor-fold>
    /**
     * Con esta variable guardamos la inclusion/exclision
     */
    @Column (name="actionIE ")
    private String IE;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.68CD0C57-13FB-201E-9ED5-00789C0FED02]
    // </editor-fold>
    /**
     * Con esta variable guardamos el array de excepciones
     */
   @OneToMany(mappedBy = "mPasoCU")
    private List<ExcepcionCU> mExcepcionCU;
   @ManyToOne
    private CasodeUso mCasodeUso;

    /**
     * Constructor de la clase
     */
     public PasoCU () {
        mExcepcionCU = new ArrayList<ExcepcionCU>();
    }
    public PasoCU (CasodeUso cu) {
        mExcepcionCU = new ArrayList<ExcepcionCU>();
        mCasodeUso = cu;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.8C754528-DA21-9B63-FDD8-CE75C1404C70]
    // </editor-fold>
    /**
     * Metodo que devuelve la accion
     * @return la accion
     */
    public String getAccion () {
        return Accion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.239609FB-D564-F65B-9276-B3377AC314AF]
    // </editor-fold>
    /**
     * Metodo que añade una accion
     * @param val es un string que representa la accion
     */
    public void setAccion (String val) {
        this.Accion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.039230D5-6F7D-1805-6CCC-D8B7AC0035A9]
    // </editor-fold>
    /**
     * Metodo que devuelve el comentario
     * @return el comentario
     */
    public String getComentarios () {
        return comentarios;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.B161A71C-3244-8424-6D8B-B1A2452D3C3A]
    // </editor-fold>
    /**
     * Metodo que añade el comentario
     * @param val es un string que representa los comentarios
     */
    public void setComentarios (String val) {
        this.comentarios = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.CABFF364-3A97-9634-6FFC-1EAA39705802]
    // </editor-fold>
    /**
     * Metodo que devuelve la condicion
     * @return la condicion
     */
    public String getCondicion () {
        return condicion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.661C1B97-3849-7D11-48B4-F279A817ED0D]
    // </editor-fold>
    /**
     * Metodo que añade la condicion
     * @param val es un string que representa la condicion
     */
    public void setCondicion (String val) {
        this.condicion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.CA89A3DD-A39C-A7DE-7B65-0FF41D755280]
    // </editor-fold>
    /**
     * Metodo que devuelve si es condicional
     * @return el booleano si es condicional
     */
    public boolean getEsCondicional () {
        return esCondicional;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.16A692B5-CE65-3445-8BD8-7F8D82809D53]
    // </editor-fold>
    /**
     * Metodo que añade si es condicional o no
     * @param val es un booleano para decir si es condicional o no
     */
    public void setEsCondicional (boolean val) {
        this.esCondicional = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.58B6C488-8864-A01B-3F16-E2A03ED18537]
    // </editor-fold>
    /**
     * Metodo que devuelve el array de excepciones
     * @return la excepcion
     */
    public List<ExcepcionCU> getExcepcionCU () {
        return (List)mExcepcionCU;
    }

    /**
     * Metodo que añade una excepcion al array
     * @param val es una excepcion
     */
     public void setExcepcionCU (List<ExcepcionCU> val) {
        this.mExcepcionCU = val;
        this.setChanged();
        this.notifyObservers();
    }
   

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.523BD7F2-638D-6274-B9B3-373EBF8935F4]
    // </editor-fold>
    /**
     * Metodo que devuelve la unidad
     * @return la unidad
     */
    public String getUnidad () {
        return unidad;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.A9443D0D-F104-AF4A-E5CD-746728712D8B]
    // </editor-fold>
    /**
     * Metodo qye añade la unidad
     * @param val es un string que representa la unidad
     */
    public void setUnidad (String val) {
        this.unidad = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.39250E68-9012-4E24-9823-52C3C8D5CA51]
    // </editor-fold>
    /**
     * Metodo que devuelve el valor
     * @return el valor
     */
    public int getValor () {
        return valor;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.59F99170-106C-2A93-EA01-72E6E9B614CE]
    // </editor-fold>
    /**
     * Metodo que añade el valor
     * @param val es un entero que representa el valor
     */
    public void setValor (int val) {
        this.valor = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.B6DB4BD1-5445-AB0A-C23B-346730AA0D13]
    // </editor-fold>
    /**
     * Metodo que crea una excepcion
     * @param Id
     * @param condicion
     * @param terminacion
     * @param AccionSistema
     * @param AccionActor
     * @param InclusionExtension
     * @param Actor
     * @param IE
     * @param Accion
     * @param valor
     * @param unidad
     * @param comentario
     * @return una excepcion
     */
    public ExcepcionCU nuevaExcepcion (int Id, String IdentP, String condicion, String terminacion, boolean AccionSistema, boolean AccionActor, boolean InclusionExtension, String Actor, String IE, String Accion, int valor, String unidad, String comentario) {
        //// Creo la instancia
        ExcepcionCU auxECU=new ExcepcionCU();
        //// Asigno los valores a los atributos
        auxECU.setId("EXCU");
        auxECU.setId_n(Id);
        auxECU.setIdent(auxECU.getId()+String.valueOf(Id)+". "+IdentP);
        auxECU.setCondicion(condicion);
        auxECU.setTerminacion(terminacion);
        auxECU.setAccionSistema(AccionSistema);
        auxECU.setAccionActor(AccionActor);
        auxECU.setInclusionExtension(InclusionExtension);
        auxECU.setActor(Actor);
        auxECU.setIE(IE);
        auxECU.setAccion(Accion);
        auxECU.setValor(valor);
        auxECU.setUnidad(unidad);
        auxECU.setComentario(comentario);
        this.getExcepcionCU().add(auxECU);
        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        persist(auxECU);
        return auxECU;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.DC99427B-559C-871A-AB88-ABD777D1D2AB]
    // </editor-fold>
    /**
     * Metodo que devuelve si es una accion del actor o no
     * @return el booleano si es accion del actor o no
     */
    public boolean getAccionActor () {
        return AccionActor;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F735EA1D-35F1-1A93-E021-1CF36407975B]
    // </editor-fold>
    /**
     * Metodo que añade un booleano de si es accion de actor o no
     * @param val es un booleano que representa si es una accion del actor
     */
    public void setAccionActor (boolean val) {
        this.AccionActor = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.9669046D-DF44-C067-2358-636A00138C2B]
    // </editor-fold>
    /**
     * Metodo que añade un booleano de si es accion de sistema o no
     * @return una booleano si es accion del sistema o no
     */
    public boolean getAccionSistema () {
        return AccionSistema;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.15A2F819-5C42-80B3-9544-622EFD774206]
    // </editor-fold>
    /**
     * Metodo que añade un booleano de si es accion de sistema o no
     * @param val es un booleano que representa si es accion del sistema o no
     */
    public void setAccionSistema (boolean val) {
        this.AccionSistema = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1C3CCF0E-D6B2-84A5-5A6F-BC11D315B6BE]
    // </editor-fold>
    /**
     * Metodo que devuelve el actor
     * @return el actor
     */
    public String getActor () {
        return Actor;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.354B1EA0-DC9E-2055-13CD-AC79ACF2D792]
    // </editor-fold>
    /**
     * Metodo que añade el actor
     * @param val es un string que representa el actor
     */
    public void setActor (String val) {
        this.Actor = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.343475A5-5950-DEA2-9851-1E29B21EA4C6]
    // </editor-fold>
    /**
     * Metodo que devuelve una inclusion/exclusion
     * @return una inclusion/exclusion
     */
    public String getIE () {
        return IE;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.8B753364-1643-D6F1-FEC8-45954F3DD56D]
    // </editor-fold>
    /**
     * Metodo que añade una inclusion/exclusion
     * @param val es un string que reprensenta una inclusion/exclusion
     */
    public void setIE (String val) {
        this.IE = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.43965B70-D2BF-2BAF-F0F6-2B2968FF8FB6]
    // </editor-fold>
    /**
     * Metodo que añade un booleano de si es inclusion/exclusion o no
     * @return si es inclusion/exclusion
     */
    public boolean getInclusionExtension () {
        return InclusionExtension;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.AADC6013-7C0F-45B7-39E6-77A79BE4E1F7]
    // </editor-fold>
    /**
     * Metodo que añade un booleano si es inclusion/exclusion o no
     * @param val es un booleano que representa si es inclusion/exclusion o no
     */
    public void setInclusionExtension (boolean val) {
        this.InclusionExtension = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param id cadena id a insertar 
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param id_n entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    @Override
    public String toString() {
        return super.toString();
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final PasoCU other = (PasoCU) obj;
        if ((this.ident == null) ? (other.ident != null) : !this.ident.equals(other.ident)) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 8;
        hash = 32 * hash + (this.ident != null ? this.ident.hashCode() : 0);
        return hash;
    }
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    public static List getData (String opt) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        return emf.createEntityManager().createQuery("SELECT p FROM PasoCU p").getResultList();
    }
    public static List getOneData (String opt) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        return emf.createEntityManager().createQuery("SELECT p FROM PasoCU p WHERE p.ident = '"+ opt +"'").getResultList();
    }

    public void eliminarPBD (PasoCU p, String ident){
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            for (int i=0; i<p.getExcepcionCU().size(); i++){
                p.eliminarPEBD(p.getExcepcionCU().get(i), ident);
            }
            Query q = em.createQuery("SELECT p FROM PasoCU p WHERE p.ident = '" + p.getIdent() + "'");
            PasoCU ps = (PasoCU) q.getSingleResult();
            em.remove(ps);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    public void actualizarPBD (PasoCU p){
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            PasoCU ps = em.find(PasoCU.class, p.getIdent());
            ps.setId_n(p.getId_n());
            ps.setCondicion(p.getCondicion());
            ps.setEsCondicional(p.getEsCondicional());
            ps.setAccionSistema(p.getAccionSistema());
            ps.setAccionActor(p.getAccionActor());
            ps.setInclusionExtension(p.getInclusionExtension());
            ps.setActor(p.getActor());
            ps.setIE(p.getIE());
            ps.setAccion(p.getAccion());
            ps.setUnidad(p.getUnidad());
            ps.setValor(p.getValor());
            ps.setComentarios(p.getComentarios());
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    public void eliminarPEBD (ExcepcionCU p, String ident){
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            Query q = em.createQuery("SELECT p FROM ExcepcionCU p WHERE p.mPasoCU.mCasodeUso.ident = '" + ident + "'");
            List<ExcepcionCU> ex = (List<ExcepcionCU>) q.getResultList();
            if (ex.size() > 0) {
                for (int i = 0; i < ex.size(); i++) {
                    ex.get(i).eliminarEBD(ex.get(i), ident);
                }
            }
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    /**
     * @return the mCasodeUso
     */
    public CasodeUso getMCasodeUso() {
        return mCasodeUso;
    }

    /**
     * @param mCasodeUso the mCasodeUso to set
     */
    public void setMCasodeUso(CasodeUso mCasodeUso) {
        this.mCasodeUso = mCasodeUso;
    }

}

