package modelo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Observable;
import javax.persistence.*;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.567087E2-9CE3-6064-3DAF-1F0042BEFA02]
// </editor-fold>
/**
 *
 * Clase Requisitofuncional, identifica a un <b>Requisito funcional</b>.
 */
@Entity
@Table (name="functional requirement")
public class RequisitoFuncional extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.29AB9B15-677F-620A-1B31-33A7A051DD5D]
    // </editor-fold>
    /**
     * Con esta variable guardamos el nombre
     */
    @Column (name="name RF")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.66EA7493-BA9E-0E3F-6AC2-9207004D7C6A]
    // </editor-fold>
    /**
     * Con esta variable guardamos la descripcion
     */
    @Column (name="description")
    private String descripcion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.197FD1A3-36B2-36AA-42A1-B639E405F71A]
    // </editor-fold>
    /**
     * Con esta variable guardamos la importancia
     */
    @Column (name="importance")
    private String importancia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.954333BB-D1E1-6E3A-E1BB-01845EAA589F]
    // </editor-fold>
    /**
     * Con esta variable guardamos la urgencia
     */
    @Column (name="urgency")
    private String urgencia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.DF9BF79B-FC88-3885-78D1-3573FD029619]
    // </editor-fold>
    /**
     * Con esta variable guardamos el estado
     */
    @Column (name="state development")
    private String estado;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.EE21EB40-DBD6-F4C6-7261-83BD88C0E030]
    // </editor-fold>
    /**
     * Con esta variable guardamos la estabilidad
     */
    @Column (name="stability")
    private String estabilidad;

    /**
     * Con esta variable guardamos el array de destino
     */
    @OneToMany
    private ArrayList<String> mDestino = new ArrayList();

    /**
     * Con esta variable guardamos el array de origen
     */
    @OneToMany
    private ArrayList<String> mOrigen = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.4F778864-9024-D40C-8697-E74DCCFC4CC8]
    // </editor-fold>
    /**
     * Constructor de la clase
     */
    public RequisitoFuncional () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.FD006E04-BD24-04C5-12B4-7C0F7AF3D3DB]
    // </editor-fold>
    /**
     * Metodo que devuelve la descripcion 
     * @return la descripcion
     */
    public String getDescripcion () {
        return descripcion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.2CDEDEB6-5F0B-A713-FDC3-665B3DBEDD7F]
    // </editor-fold>
    /**
     * Metodo que añade la decripcion 
     * @param val es un string que representa la descripcion
     */
    public void setDescripcion (String val) {
        this.descripcion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.460D9665-E193-7E6A-76BE-ADC3D7EB6EC7]
    // </editor-fold>
    /**
     * Metodo que devuelve la estabilidad
     * @return la estabilidad
     */
    public String getEstabilidad () {
        return estabilidad;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.B7D24CAE-8973-C507-56CD-4FD14BE33E19]
    // </editor-fold>
    /**
     * Metodo que añade la estabilidad
     * @param val es un string que representa la estabilidad
     */
    public void setEstabilidad (String val) {
        this.estabilidad = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.2DBE453B-A2F6-731D-1929-5DF3B3AD36C7]
    // </editor-fold>
    /**
     * Metodo que devuelve el estado
     * @return el estado
     */
    public String getEstado () {
        return estado;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.B3357BFD-2338-2B56-9478-0CF4444F47D7]
    // </editor-fold>
    /**
     * Metodo que añade el estado
     * @param val es un string que representa el estado
     */
    public void setEstado (String val) {
        this.estado = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.8D524E02-663C-F25E-535B-1EC0342556FE]
    // </editor-fold>
    /**
     * Metodo que devuelve la importancia
     * @return la importancia
     */
    public String getImportancia () {
        return importancia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7AF139CC-F891-F49F-E6C8-6A83F478C1D3]
    // </editor-fold>
    /**
     * Metodo que añade la importancia
     * @param val es un string que representa la importancia
     */
    public void setImportancia (String val) {
        this.importancia = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.A84E0498-A15A-0485-1DFE-D6895663E9FA]
    // </editor-fold>
    /**
     * Metodo que devuelve el nombre
     * @return el nombre
     */
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.12712005-8886-FE6C-2C1C-2B1414436C2B]
    // </editor-fold>
    /**
     * Metodo que añade el nombre
     * @param val es un string que representa el nombre
     */
    public void setNombre (String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.BC964921-FF73-E6A8-3904-EB9F46ABD6F4]
    // </editor-fold>
    /**
     * Metodo que devuelve la urgencia
     * @return la urgencia
     */
    public String getUrgencia () {
        return urgencia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.6F6C998F-247B-36D3-D54B-48FF1BD65ADB]
    // </editor-fold>
    /**
     * metodo que añade la urgencia
     * @param val es un string que representa la urgencia
     */
    public void setUrgencia (String val) {
        this.urgencia = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve el destino
     * @return el mDestino
     */
    public ArrayList<String> getMDestino() {
        return mDestino;
    }

    /**
     * Metodo que añade el destino
     * @param mDestino es el destino
     */
    public void setMDestino(ArrayList<String> mDestino) {
        this.mDestino = mDestino;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve el origen
     * @return el mOrigen
     */
    public ArrayList<String> getMOrigen() {
        return mOrigen;
    }

    /**
     * Metodo que añade el origen
     * @param mOrigen el origen
     */
    public void setMOrigen(ArrayList<String> mOrigen) {
        this.mOrigen = mOrigen;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param id cadena id a insertar 
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param id_n entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

}

