package modelo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Observable;
import javax.persistence.*;


// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.162C55A0-966B-DD8B-9E1D-FCFD494EAADD]
// </editor-fold>
/**
 *
 * Clase RequisitoNoFuncional, identifica a un <b>Requisito NO funcional</b>.
 */
@Entity
@Table(name="no functional requirement")
public class RequisitoNoFuncional extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.ED8EB4F8-4761-200F-38B7-4F9BDF13358D]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el nombre del requisito no funcional
     */
    @Column (name="name RNF")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.827D29D8-18C6-BA41-01C2-7D1D07A08BA2]
    // </editor-fold>
    /**
     * Con esta variable guardaremos la descripcion
     */
    @Column (name="description")
    private String descripcion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.0352D26F-3937-0B30-C2BF-4CF9E569194F]
    // </editor-fold>
    /**
     * Con esta variable guardaremos la importancia
     */
    @Column (name="importance")
    private String importancia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.81E2A62D-EAC6-C64B-8B37-955E6B00C368]
    // </editor-fold>
    /**
     * Con esta variable guardaremos la urgencia
     */
    @Column (name="urgency")
    private String urgencia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.EB77B207-2B1F-5151-5CD8-8518CA9FE2D2]
    // </editor-fold>
    /**
     * Con esta variable guardaremos la estabilidad
     */
    @Column (name="stability")
    private String estabilidad;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.03292438-C5EC-840A-4D7B-9A027FA3868D]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el estado
     */
    @Column (name="state development")
    private String estado;

    /**
     * Con esta variable guardaremos el array de destino
     */
    @OneToMany
    private ArrayList<String> mDestino = new ArrayList();

    /**
     * Con esta variable guardaremos el array de origen
     */
    @OneToMany
    private ArrayList<String> mOrigen = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.35454BBA-631B-5989-68C8-3E1EB8BF656A]
    // </editor-fold>
    /**
     * Constructor de la clase
     */
    public RequisitoNoFuncional () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.35A17D55-C87F-67E8-BD22-F5B03D61523F]
    // </editor-fold>
    /**
     * Metodo que devuelve la descripcion
     * @return la descripcion
     */
    public String getDescripcion () {
        return descripcion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.721AEB50-1523-1FC8-6655-736FA5FD45AA]
    // </editor-fold>
    /**
     * Metodo que añade la descripcion
     * @param val es el string que representa la descripcion
     */
    public void setDescripcion (String val) {
        this.descripcion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.2B6BCF00-5D09-512B-AB1D-761D768E5F9E]
    // </editor-fold>
    /**
     * Metodo que devuelve la estabilidad
     * @return la estabilidad
     */
    public String getEstabilidad () {
        return estabilidad;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.9696C292-981A-8BEF-7EB0-6CF82B9DF803]
    // </editor-fold>
    /**
     * Metodo que añade la estabilidad
     * @param val es un string que representa la estabilidad
     */
    public void setEstabilidad (String val) {
        this.estabilidad = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.4412D31C-D692-A997-EC29-10E6A4B62D62]
    // </editor-fold>
    /**
     * Metodo que devuelve el estado
     * @return el estado
     */
    public String getEstado () {
        return estado;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.8091642D-170B-A363-637E-A16AADCA7A30]
    // </editor-fold>
    /**
     * Metodo que añade el estado
     * @param val es un string que representa el estado
     */
    public void setEstado (String val) {
        this.estado = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7B571341-1916-2A33-C6C8-04B8721DF9C3]
    // </editor-fold>
    /**
     * Metodo que devuelve la importancia
     * @return la importacia
     */
    public String getImportancia () {
        return importancia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.35492436-79D2-3A97-9A96-C9EAAA60F50C]
    // </editor-fold>
    /**
     * metodo que añade la importancia
     * @param val es un string que representa la importancia
     */
    public void setImportancia (String val) {
        this.importancia = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.4AD665C9-3EBC-65BB-CA47-688300373E8F]
    // </editor-fold>
    /**
     * Metodo que devuelve el nombre 
     * @return el nombre
     */
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.9FA097F5-18C2-A38D-CCE4-8CE47FF8E141]
    // </editor-fold>
    /**
     * Metodo que añade el nombre
     * @param val es un string que representa el nombre
     */
    public void setNombre (String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E9884CD0-CF7A-7DB5-8B59-E5783401E0D5]
    // </editor-fold>
    /**
     * Metodo que devuelve la urgencia
     * @return la urgencia
     */
    public String getUrgencia () {
        return urgencia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.56CED68D-81A5-B073-0F02-E738B22C99F4]
    // </editor-fold>
    /**
     * Metodo que añade la urgencia
     * @param val es un string que representa la urgencia
     */
    public void setUrgencia (String val) {
        this.urgencia = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve el array de destino
     * @return el destino
     */
    public ArrayList<String> getMDestino() {
        return mDestino;
    }

    /**
     * Metodo qye añade el array de destino
     * @param mDestino es un array de destino
     */
    public void setMDestino(ArrayList<String> mDestino) {
        this.mDestino = mDestino;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve el array de origen
     * @return el origen
     */
    public ArrayList<String> getMOrigen() {
        return mOrigen;
    }

    /**
     * Metodo qye añade el array de origen
     * @param mOrigen es un arrat de origen
     */
    public void setMOrigen(ArrayList<String> mOrigen) {
        this.mOrigen = mOrigen;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param id cadena id a insertar 
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param id_n entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

}

